{* Serge Gavrilov ( C ) 2003 ************************************************ *}

{
  Use this file for sorting project files in Delphi 7 project manager window.
  Just include this file in any design package and then choose menu item
  Help->Sort project manager.

  sergegavrilov@mail.ru
}

unit CvSpm;

interface

{$warn UNIT_DEPRECATED off}

{$I-}


uses
  SysUtils, Classes, Controls, Dialogs, Windows, ExptIntf, ComCtrls, CommCtrl;

type
  TCvSpmCl = class( TIExpert )
  public
    function GetName: string; override; stdcall;
    function GetAuthor: string; override; stdcall;
    function GetComment: string; override; stdcall;
    function GetPage: string; override; stdcall;
    function GetGlyph: HICON; override; stdcall;
    function GetStyle: TExpertStyle; override; stdcall;
    function GetState: TExpertState; override; stdcall;
    function GetIDString: string; override; stdcall;
    function GetMenuText: string; override; stdcall;
    procedure Execute; override; stdcall;
  end;

procedure Register;

implementation

function TCvSpmCl.GetName;
begin
  result := 'TCvSpmCl';
end;
function TCvSpmCl.GetAuthor;
begin
  result := 'Serge Gavrilov (c) 2003. sergegavrilov@mail.ru';
end;
function TCvSpmCl.GetComment;
begin
  result := 'Serge Gavrilov (c). Sort project manager';
end;
function TCvSpmCl.GetGlyph;
begin
  result := 0;
end;
function TCvSpmCl.GetPage;
begin
  result := 'Gsv';
end;
function TCvSpmCl.GetStyle;
begin
  result := esStandard;
end;
function TCvSpmCl.GetState;
begin
  result := [ esEnabled ];
end;
function TCvSpmCl.GetIDString;
begin
  result := 'Gsv.Spm expert';
end;
function TCvSpmCl.GetMenuText;
begin
  {translate part}            
  result := 'Serge Gavrilov (c). Sort project manager';
end;
procedure TCvSpmCl.Execute;
var
  oStr, oStrRes, oStrSort, oStrTop, oStrBot : TStringList;
  iFile : Text;
  sFile : string;
  sLine : string;
  isLast : boolean;
  i, iUsesIndex : integer;
  function Find_Use : boolean;
  begin
    while not Eof( iFile )
    do  begin
        ReadLn( iFile, sLine );
        oStr.Add( sLine );
        if CompareText( Trim( sLine ), 'uses' ) = 0
        then  begin
              iUsesIndex := oStr.Count - 1;
              result := true;
              exit;
              end;
        end;
    result := false;
  end;
  function GetLine : boolean;
  begin
    result := false;
    isLast := false;
    sLine := '';
    while true
    do  begin
        if Eof( iFile ) then exit;
        ReadLn( iFile, sLine );
        sLine := TrimRight( sLine );
        if Trim( sLine ) = '' then Continue;
        result := true;
        if Copy( sLine, Length( sLine ), 1 ) = ';' then isLast := true;
        exit;
        end;
  end;
  procedure ReadRestLines;
  begin
    while not Eof( iFile )
    do  begin
        ReadLn( iFile, sLine );
        oStr.Add( sLine );
        end;
  end;
begin
  oStrRes := TStringList.Create;
  try
    sFile := ToolServices.GetProjectName;
    if sFile = ''
    then  begin
          {translate part}
          ShowMessage( 'There is''not opening project' );
          exit;
          end;
    ToolServices.SaveProject;
    AssignFile( iFile, sFile );
    Reset( iFile );
    if IOResult <> 0
    then  begin
          {translate part}
          ShowMessage( 'Cant''t open file for reading: ' + sFile );
          exit;
          end;
    try
      oStr := TStringList.Create;
      try
        if not Find_Use
        then  begin
              {translate part}
              ShowMessage( 'can''t find word "uses"' );
              exit;
              end;
        oStrSort := TStringList.Create;
        oStrTop := TStringList.Create;
        oStrBot := TStringList.Create;
        try
          while GetLine
          do  begin
              Delete( sLine, Length( sLine ), 1 );
              if Pos( '{top}', sLine ) > 0
              then  oStrTop.Add( sLine )
              else  if Pos( '{bot}', sLine ) > 0
                    then  oStrBot.Add( sLine )
                    else  begin
                          oStrSort.Add( sLine );
                          end;
              if isLast then break;
              end;
          ReadRestLines;
          for i := 0 to iUsesIndex
          do  oStrRes.Add( oStr[ i ] );
          oStrSort.Sort;
          oStrTop.Sort;
          oStrBot.Sort;
          for i := 0 to oStrTop.Count - 1
          do  oStrRes.Add( oStrTop[ i ] + ',' );
          for i := 0 to oStrSort.Count - 1
          do  oStrRes.Add( oStrSort[ i ] + ',' );
          for i := 0 to oStrBot.Count - 1
          do  oStrRes.Add( oStrBot[ i ] + ',' );
          if oStrRes.Count > 0
          then  begin
                sLine := oStrRes[ oStrRes.Count - 1 ];
                Delete( sLine, Length( sLine ), 1 );
                sLine := sLine + ';';
                oStrRes[ oStrRes.Count - 1 ] := sLine;
                end;
          for i := iUsesIndex + 1 to oStr.Count - 1
          do  oStrRes.Add( oStr[ i ] );
        finally
          oStrSort.Free;
          oStrTop.Free;
          oStrBot.Free;
        end;
      finally
        oStr.Free;
      end;
    finally
      CloseFile( iFile );
    end;
    ReWrite( iFile );
    if IOResult <> 0
    then  begin
          {translate part}
          ShowMessage( 'Can''t open file for writing: ' + sFile );
          exit;
          end;
    try
      for i := 0 to oStrRes.Count - 1
      do  begin
          sLine := oStrRes[ i ];
          WriteLn( iFile, sLine );
          end;
    finally
      CloseFile( iFile );
    end;
    ToolServices.ReloadFile( sFile );
  finally
    oStrRes.Free;
  end;
end;

procedure Register;
begin
  RegisterLibraryExpert( TCvSpmCl.Create );
end;

end.
